## ecl 11.1.1

=== msvc/c/Makefile ===
#
#			Makefile for ECL core library
#
top_srcdir = ..\..\src
srcdir	= ..\..\src\c

!if "$(ECL_WIN64)" != ""
ECL_FFI_OBJ=
ECL_FPE_CODE=fpe_none.c
!else
ECL_FFI_OBJ=ffi_x86.obj
ECL_FPE_CODE=fpe_x86.c
!endif

!if "$(ECL_THREADS)" != ""
ECL_THREADS_FLAG=1
THREADS_OBJ= process.obj mutex.obj condition_variable.obj rwlock.obj
!else
ECL_THREADS_FLAG=0
THREADS_OBJ=
!endif

!if "$(ECL_UNICODE)" != ""
ECL_UNICODE_FLAG=1
!else
ECL_UNICODE_FLAG=0
!endif

!if "$(ECL_SSE)" != ""
ECL_SSE_FLAG=1
!else
ECL_SSE_FLAG=0
!endif

# Programs used by "make":
#
TRUE_CC = cl
CC	= cl
CFLAGS	= -c $(ECL_CFLAGS) -DECL_API="__declspec(dllexport)" -I./ -I../ -I$(srcdir) -I$(top_srcdir)/gc/include  -I$(top_srcdir)/gc/include/private

SHELL	= /bin/sh
RM	= del
CP      = copy /Y
MV      = move /Y
LINK    = link
EXE	= .exe
DPP	= .\dpp$(EXE)

# Data for installation
#
INSTALL = @INSTALL@
INSTALL_DATA = @INSTALL_DATA@
prefix=@prefix@
exec_prefix=$(prefix)
libdir=$(prefix)\lib\ecl

# Files

HDIR	= $(top_srcdir)\h
HFILES	= ..\ecl\config.h ..\ecl\atomic_ops.h $(HDIR)\ecl.h $(HDIR)\ecl-cmp.h\
	$(HDIR)\object.h $(HDIR)\cs.h $(HDIR)\stacks.h\
	$(HDIR)\external.h $(HDIR)\eval.h\
	$(HDIR)\number.h $(HDIR)\page.h $(HDIR)\unify.h\
	$(HDIR)\internal.h $(HDIR)\ecl-inl.h $(HDIR)\bytecodes.h \
	$(HDIR)\impl\math_dispatch.h

OBJS	= main.obj symbol.obj package.obj list.obj\
	apply.obj eval.obj interpreter.obj compiler.obj disassembler.obj \
	instance.obj gfun.obj reference.obj character.obj\
	file.obj read.obj print.obj error.obj string.obj cfun.obj\
	parse_integer.obj parse_number.obj \
	float_to_digits.obj float_to_string.obj \
	integer_to_string.obj write_ugly.obj \
	write_object.obj write_symbol.obj \
	write_array.obj write_list.obj write_code.obj \
	write_sse.obj print_unreadable.obj \
	libraries.obj backtrace.obj \
	cos.obj sin.obj tan.obj atan.obj \
	cosh.obj sinh.obj tanh.obj \
	exp.obj expt.obj log.obj \
	sqrt.obj abs.obj \
	zerop.obj plusp.obj minusp.obj \
	negate.obj conjugate.obj \
	one_plus.obj one_minus.obj \
	plus.obj minus.obj times.obj divide.obj \
	number_compare.obj number_equalp.obj minmax.obj \
	typespec.obj assignment.obj \
	predicate.obj big.obj number.obj\
	num_pred.obj num_arith.obj num_co.obj\
	num_log.obj num_rand.obj array.obj sequence.obj cmpaux.obj\
	macros.obj backq.obj stacks.obj \
	time.obj unixint.obj\
	mapfun.obj multival.obj hash.obj format.obj pathname.obj\
	structure.obj load.obj unixfsys.obj unixsys.obj \
	ffi.obj alloc_2.obj tcp.obj $(THREADS_OBJ) serialize.obj \
	$(ECL_FFI_OBJ)

all:	$(DPP) ..\eclmin.lib ..\cinit.obj

.SUFFIXES: .obj .c .d

{$(srcdir:\=/)}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/arch}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/reader}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/printer}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/ffi}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/numbers}.d{}.c:
	$(DPP) $< $@
{$(srcdir:\=/)/threads}.d{}.c:
	$(DPP) $< $@

#.d.c:
#	$(DPP) $< $@
.c.obj:
	$(CC) $(CFLAGS) /Fo$@ $<

.PHONY:	all

cut.exe: $(top_srcdir)/util/cut.c
	$(CC) $(LDFLAGS) /Fecut.exe $(top_srcdir)/util/cut.c

..\eclmin.lib: $(OBJS:.obj=.c) all_symbols.c $(OBJS) all_symbols.obj all_symbols2.obj
	-$(RM) $@
	$(LINK) -lib -out:$@ $(OBJS)

clean:
	-for %f in ($(OBJS:.obj=.c) all_symbols.c) do $(RM) %f
	-for %f in ($(OBJS) all_symbols.obj all_symbols2.obj) do $(RM) %f
	-$(RM) *.pdb
	-for %f in (..\ecl\config.h dpp dpp.obj $(DPP) cut.exe cut.obj \
	            ..\eclmin.lib ..\cinit.obj cinit.c symbols_list2.h) \
	     do $(RM) %f
	-for %f in (..\ecl\*.h) do $(RM) %f
	-for %f in (cut.exe cut.obj dpp.exe dpp.obj) do $(RM) %f
	-del /S /Q ..\ecl\atomic*

# Build rules

$(DPP): $(srcdir)/dpp.c $(srcdir)/symbols_list2.h ../ecl/config.h
	$(TRUE_CC) -I.. -I./ $(srcdir)/dpp.c  -o $@
$(HFILES): ../ecl/config.h.msvc6 Makefile
	-mkdir ..\ecl\impl
	cut.exe "@ECL_FPE_CODE@" "$(srcdir:\=/)/arch/$(ECL_FPE_CODE)" \
		"@ECL_VERSION_NUMBER@" "$(ECL_VERSION_NUMBER)" \
		"@ECL_THREADS@" "$(ECL_THREADS_FLAG)" \
		"@ECL_UNICODE@" "$(ECL_UNICODE_FLAG)" \
		"@ECL_SSE2@" "$(ECL_SSE_FLAG)" \
	        < ..\ecl\config.h.msvc6 > $@
	xcopy /SYI $(top_srcdir)\h\* ..\ecl
	-mkdir ..\ecl\atomic_ops
	-mkdir ..\ecl\atomic_ops\sysdeps
	xcopy /SYI $(top_srcdir)\gc\libatomic_ops-1.2\src\atomic_ops.h ..\ecl
	xcopy /SYI $(top_srcdir)\gc\libatomic_ops-1.2\src\atomic_ops\generalize*.h ..\ecl\atomic_ops
	xcopy /SYI $(top_srcdir)\gc\libatomic_ops-1.2\src\atomic_ops\sysdeps\* ..\ecl\atomic_ops\sysdeps

#
# GCC might break this code
#
gbc.o: gbc.c $(HFILES)
	$(CC) $(CFLAGS) -O0 gbc.c /Fo$@
#
# This reduces the overhead of jumping to other functions
#
apply.o: apply.c $(HFILES) $(HDIR)/cs.h
	$(CC) $(CFLAGS) apply.c /Fo$@
#
# These files are interrelated
#
all_symbols.obj: all_symbols.c
	$(CC) $(CFLAGS) -Fo$@ -I../ -I./ all_symbols.c
all_symbols2.obj: all_symbols.c
	$(CC) $(CFLAGS) -DECL_FINAL -Fo$@ -I../ -I./ all_symbols.c
#
# This is in another directory
#
../cinit.obj: cinit.c
	$(CC) $(CFLAGS) -I../ -I./ /Focinit.obj cinit.c
	$(MV) cinit.obj ..\

=== debian/changelog ===
ecl (11.1.1-4) unstable; urgency=low

  * disable gengc on ia64 again

 -- Christoph Egger <christoph@debian.org>  Fri, 11 Mar 2011 20:01:14 +0100

ecl (11.1.1-3) unstable; urgency=low

  * build against libgmp-dev instead of libgmp3-dev

 -- Christoph Egger <christoph@debian.org>  Fri, 11 Mar 2011 18:34:26 +0100

ecl (11.1.1-2) unstable; urgency=low

  * New upstream.
  * Move to use quilt
  * Removed Luca from uploaders
  * Updated Standards-Version no real changes
  * Use system boehm libgc again
  * Fixed format of NEWS file
  * We forgot to remove the postrm, causing /usr/bin/ecl to get 
    deleted on upgrades. Fixed this. 

 -- Peter Van Eynde <pvaneynd@debian.org>  Tue, 08 Mar 2011 08:08:56 +0100

ecl (11.1.1-1) experimental; urgency=low

  [ Luca Capello ]
  * debian/control:
    + remove myself from Uploaders:.

  [ Christoph Egger ]
  * New upstream release
  * build against system libatomic-ops
  * Temporarily disable doc build (fails)
  * Remove dh-lisp / clc -- it's expected to disappear

 -- Christoph Egger <christoph@debian.org>  Fri, 04 Mar 2011 00:04:30 +0100

ecl (10.3.1-3) experimental; urgency=low

  * Version for experimental
    * Build against system libgc again (Closes: #554081)

 -- Christoph Egger <christoph@debian.org>  Sun, 18 Jul 2010 12:46:53 +0200

ecl (10.3.1-2) unstable; urgency=low

  * Add a build-depends for install-info (Closes: #574701)

 -- Peter Van Eynde <pvaneynd@debian.org>  Wed, 31 Mar 2010 09:14:46 +0200

ecl (10.3.1-1) unstable; urgency=low

  * New upstream.
  * Force INSTALL_INFO to ginstall. (Closes: #562433, 573659) 

 -- Peter Van Eynde <pvaneynd@debian.org>  Tue, 16 Mar 2010 21:50:19 +0100

ecl (9.12.3-1) unstable; urgency=low

  * New upstream.
  * Changed copyright link to LGPL-2
  * fix spelling typo in src/clx/image.lisp
  * fix spelling typo in contrib/sockets/sockets.lisp
  * fix spelling typo in src/clos/streams.lsp

 -- Peter Van Eynde <pvaneynd@debian.org>  Thu, 31 Dec 2009 09:56:10 +0100

ecl (9.10.2-1) unstable; urgency=low

  * New upstream release. 
  * use buildin boehm gc for now

 -- Peter Van Eynde <pvaneynd@debian.org>  Mon, 12 Oct 2009 11:47:27 +0100

ecl (9.8.4-2) unstable; urgency=low

  * I should not have changed to lisp section
  * Force the configure script to use ginstall-info, (Closes: #545625)

 -- Peter Van Eynde <pvaneynd@debian.org>  Thu, 24 Sep 2009 11:10:07 +0200

ecl (9.8.4-1) unstable; urgency=low

  * New upstream with major changes.
  * enable threading again
  * Changed to the lisp Section
  * Updated Standards-Version no real changes
  * Added linitian override for the clc directory
  * Added debian/README.building file

 -- Peter Van Eynde <pvaneynd@debian.org>  Wed, 02 Sep 2009 09:10:09 +0100

ecl (9.6.1-1) unstable; urgency=low

  * New upstream release. 
  * Fixed watch file
  * fixed clean to remove src/gc/configure.in file

 -- Peter Van Eynde <pvaneynd@debian.org>  Wed, 17 Jun 2009 22:42:16 +0200

ecl (9.4.1-1) unstable; urgency=low

  * New upstream with major changes.
  * now using debhelper version 7
  * updated standard version without any real changes
  * use dh_prep instead of dh_clean -k
  * use redirected sf.net url for watch file
  * added ${misc:Depends} for ecl-doc
  * remove redundant Section field for binary package
  * remove empty usr/lib/ecl/h directory
  * fixed gnu typo in control file
  * fixed watch file to see new version numbering scheme

 -- Peter Van Eynde <pvaneynd@debian.org>  Wed, 29 Apr 2009 05:58:47 +0200

ecl (0.9j-20080306-5) unstable; urgency=low

  * debian/control:
    + Build-Depends: on chrpath to remove unnecessary rpath headers
      from binaries in /usr/lib/ecl/, thanks to Bill Allombert
      <bill.allombert@math.u-bordeaux1.fr> (Closes: #495756).
    + Depends: on gcc, it's required at installation and everytime
      you want to produce a loadable object file.

  * debian/rules:
    + add chrpath call to 'install' target.

 -- Luca Capello <luca@pca.it>  Tue, 09 Sep 2008 21:54:43 +0200

ecl (0.9j-20080306-4) unstable; urgency=low

  * debian/control:
    + build-depend on quilt to manage patches.

  * debian/patches/series: new file.
  * debian/patches/01_src-configure-add-missing-test.patch:
    + add missing `test' invocation in x86_64 check for dynamic FFI.

  * debian/rules:
    + adapt to quilt.

 -- Luca Capello <luca@pca.it>  Mon, 07 Jul 2008 18:49:53 +0200

ecl (0.9j-20080306-3) unstable; urgency=low

  * debian/rules:
    + fix FTBFS: move ls call from binary-arch to binary-indep,
      thanks to Bastian Blank <waldi@debian.org> (Closes: #488811).

 -- Luca Capello <luca@pca.it>  Mon, 07 Jul 2008 00:18:07 +0200

ecl (0.9j-20080306-2) unstable; urgency=low

  * debian/control:
    + add myself to Uploaders:.
    + add Vcs-Browser field.
    + remove trailing spaces from the long Description:.
    + conflict with common-lisp-controller << 6.15 because of #477169.
    + correct Info/HTML capitalizations in ecl-doc long Description:.
    - remove xutils from Build-Depends:.
    - remove traling empty lines.

  * debian/ecl-doc.doc-base:
    + new section 'Programming' (thanks to lintian).

  * debian/rules:
    + fix FTBFS: instead of simply reverting swap of binary-indep
      and binary-arch targets, create the arch-dependent "ecl"
      package in binary-arch and the arch-independent "ecl-doc" in
      binary-indep, thanks to Sebastian Bober <sbober@servercare.de>
      for the patch (Closes: #471223).
    + remove trailing spaces.
    + correct lintian warning debian-rules-ignores-make-clean-error.

 -- Luca Capello <luca@pca.it>  Sun, 15 Jun 2008 19:30:07 +0200

ecl (0.9j-20080306-1) unstable; urgency=low

  * New upstream version.
  * updated standard version no real changes
  * added Homepage
  * Use default gcc (Closes: #463291)
  * Changed to group maintanance
  * Corrected Vcs-Git control field
  * swap binary-indep and binary-arch round

 -- Peter Van Eynde <pvaneynd@debian.org>  Fri, 07 Mar 2008 22:13:58 +0100



=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# FOR AUTOCONF 2.52 AND NEWER ONLY
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_HOST_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

#export CC=/usr/bin/gcc-4.1

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

# gengc doesn't work on ia64 right now -- check again for next version
ifneq ($(DEB_HOST_ARCH),ia64)
  confflags += --enable-gengc
endif

# force to use ginstall-info:
export INSTALL_INFO=/usr/bin/ginstall-info

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
	chmod a+x configure \
	 src/gmp/macos/configure \
	 src/gmp/configure \
	 src/configure \
	 src/gmp/mpn/m4-ccas

	touch src/configure.in && \
	touch src/aclocal.m4 && \
	touch src/configure configure

	./configure $(confflags) \
	   --prefix=/usr --mandir=\$${prefix}/share/man \
	   --infodir=\$${prefix}/share/info \
	   --with-system-gmp=yes \
	   --with-tcp \
	   --with-clx  \
	   --enable-threads=yes \
	   --enable-boehm=system  \
	   --with-x

	touch config.status

build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: config.status
	dh_testdir -a

	$(MAKE)

	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: config.status
	dh_testdir -i
#	DISABLED -- doc not building
#	$(MAKE) -C build/doc
	touch build-indep-stamp

clean: 
	dh_testdir
	dh_testroot
	rm -f build-*-stamp
#	-test -r /usr/share/misc/config.sub && \
#           cp -f /usr/share/misc/config.sub src/gc/config.sub
#	-test -r /usr/share/misc/config.guess && \
#           cp -f /usr/share/misc/config.guess src/gc/config.guess
#	-test -r /usr/share/misc/config.sub && \
#           cp -f /usr/share/misc/config.sub src/config.sub
#	-test -r /usr/share/misc/config.guess && \
#           cp -f /usr/share/misc/config.guess src/config.guess
	# do this manually on a big change:
	# autoreconf --force
	# Add here commands to clean up after the build process.
	# correct lintian warning debian-rules-ignores-make-clean-error
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f src/gc/configure.in

	rm -rf build

	dh_clean

install: build-arch
	dh_testdir -a
	dh_testroot -a
	dh_prep -a
	dh_installdirs -a

#	Add here commands to install the package into debian/ecl
	$(MAKE) install prefix=$(CURDIR)/debian/ecl/usr

#	DISABLED -- doc currently not building
#
#	rm $(CURDIR)/debian/ecl/usr/share/doc/LGPL
#	rm $(CURDIR)/debian/ecl/usr/share/doc/Copyright

#	rm $(CURDIR)/debian/ecl/usr/share/info/ecl.info \
#	   $(CURDIR)/debian/ecl/usr/share/info/clx.info \
#	   $(CURDIR)/debian/ecl/usr/share/info/ecldev.info

#	rm $(CURDIR)/debian/ecl/usr/share/info/dir

#	rmdir $(CURDIR)/debian/ecl/usr/share/info

	find $(CURDIR)/debian -name "*.lsp" -print0 | \
	   xargs -0 chmod a-x || true

#	remove rpath from /us/lib/ecl/ binaries (bug #495756)
#	this is a workaround until upstream properly fixes it
	find $(CURDIR)/debian/ecl/usr/lib/ -name "*.fas" -print0 | \
	   xargs -0 chrpath -d
	chrpath -d $(CURDIR)/debian/ecl/usr/bin/ecl $(CURDIR)/debian/ecl/usr/lib/libecl.so.11.1.1

	cp debian/overrides.ecl $(CURDIR)/debian/ecl/usr/share/lintian/overrides/ecl


# Build architecture-independent files here.
binary-indep: build-indep
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
	ls -l $(CURDIR)/debian/ecl-doc/usr/share/info/
	dh_installdocs -i
	dh_installchangelogs -i
#	dh_installinfo -v -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build-arch install
	dh_testdir -a
	dh_testroot -a
#	dh_installdebconf
	dh_installdocs -a
	dh_installexamples -a
	dh_installmenu -a
	dh_installman -a
#	dh_undocumented
	dh_installchangelogs -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
#	dh_lisp -a ecl
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build build-arch build-indep clean binary-indep binary-arch binary install

## ecl 11.1.1+dfsg1

=== msvc/Makefile ===
#
#		Makefile for ECoLisp
#
top_srcdir= ..\src
srcdir	= ..\src

# =============================================================
# ECL configuration
# <BEGIN>

SHORT_SITE_NAME   =
LONG_SITE_NAME    =
ECL_VERSION       = 11.1.1
ECL_VERSION_NUMBER= 110101
ARCHITECTURE      = PENTIUM4
SOFTWARE_TYPE     = NT
SOFTWARE_VERSION  = 5.0
THEHOST           = win32

# Define to 1 to make a 64-bit build
# ECL_WIN64 =

# Define here the processor type to compile GMP library
# with maximum optimization. Possible values are:
# 	gc -> generic implementation
# 	p0 -> Pentium processor
# 	p3 -> Pentium III processor
# 	p4 -> Pentium IV processor
GMP_TYPE      = gc

# Set it to non-empty to include Win32 thread support
# Currently it is NOT SUPPORTED to build ECL without threads. The reason
# is that certain exception handlers in Windows always use new threads.
# Without them, ECL would be an even more fragile piece of software.
ECL_THREADS   = 1

# Set it to non-empty to include support for Unicode characters
ECL_UNICODE   =

# Set it to non-empty to enable Win32 debug support
#ECL_DEBUG = 1

# Set it to non-empty to support SSE2 intrinsics
ECL_SSE =

# Add the extensions to include in the build process. Comment any
# of the following lines to remove a feature from the build process
# LISP->C compiled
ECL_CMP     =
# ASDF support
ECL_ASDF    =
# TCP support
ECL_SOCKETS =
# X Windows support
# ECL_CLX     = 1
# Regression Tests support
ECL_RT      =
# Defsystem support
ECL_DEFSYS  =
# Profiling
ECL_PROFILE =

# <END> (ECL configuration)
# =============================================================

TAR_DIR = %CD%\ecl-$(ECL_VERSION)

# Programs used by "make":
#

CC	= cl
LIBS	= eclgc.lib eclgmp.lib user32.lib ws2_32.lib shell32.lib
RM	= del
RMDIR   = rmdir /Q /S
MKDIR   = mkdir
EXE	= .exe
CP      = copy /Y
MV      = move /Y
MSDEV   = msdev
MKNSI   = makensis.exe

# ==================== Flags ====================

!if "$(ECL_SSE)" != ""
CFLAGS_SSE=/arch:SSE2
!endif

!if "$(ECL_WIN64)" != ""
GMP_BITS=64
GC_CPU=AMD64
ARCHITECTURE=AMD64
VCREDIST=vcredist_x64.exe
!else
GMP_BITS=32
GC_CPU=i386
ARCHITECTURE=PENTIUM4
VCREDIST=vcredist_x86.exe
!endif

#
# Configuration-specific (Debug/Release) options
#
!if "$(ECL_DEBUG)" != ""
CFLAGS_OPTIMIZE = /Od
CFLAGS_CONFIG = /Zi /D_DEBUG /MDd $(CFLAGS_OPTIMIZE) $(CFLAGS_SSE)
LDFLAGS_CONFIG = /debug /nodefaultlib:msvcrt.lib
SHARED_LDFLAGS = /LDd
GCFLAGS =
!else
CFLAGS_OPTIMIZE = /O2
CFLAGS_CONFIG = /DNDEBUG /MD $(CFLAGS_OPTIMIZE) $(CFLAGS_SSE)
LDFLAGS_CONFIG = /nodefaultlib:msvcrtd.lib
SHARED_LDFLAGS = /LD
GCFLAGS = nodebug=1
!endif

CFLAGS  = /EHsc /DGC_DLL /DGC_BUILD /nologo /D_CRT_SECURE_NO_DEPRECATE $(CFLAGS_CONFIG)
LDFLAGS	= /link /incremental:no /nologo /nodefaultlib:libcmt /nodefaultlib:libcmtd /nodefaultlib:libc /nodefaultlib:libcd $(LDFLAGS_CONFIG)


# Additional configuration for thread support
#
!if "$(ECL_THREADS)" == ""
ENV_EXPORT = cl_env,DATA
!else
ENV_EXPORT = ecl_process_env
CFLAGS     = $(CFLAGS)
DEF        = ecl-threads.def
!endif

# Additional configuration for Unicode support
#
!if "$(ECL_UNICODE)" != ""
UCDDAT     = ucd.dat
!endif

!MESSAGE C++ compiler flags: $(CFLAGS)
!MESSAGE C++ linker flags: $(LDFLAGS)

# ==================== Where To Install Things ====================

# The default location for installation.  Everything is placed in
# subdirectories of this directory.  The default values for many of
# the variables below are expressed in terms of this one, so you may
# not need to change them.  This defaults to /usr/local.
prefix=%CD%\package
exec_prefix=$(prefix)
bindir=$(prefix)
libdir=$(prefix)
includedir=$(prefix)
docdir=$(prefix)\doc

# Programs used by "make install":
#
SHELL = @SHELL@
INSTALL	= @INSTALL@
INSTALL_PROGRAM = @INSTALL_PROGRAM@
INSTALL_SCRIPT = @INSTALL_SCRIPT@
INSTALL_DATA = @INSTALL_DATA@
mkinstalldirs = $(SHELL) $(top_srcdir)/gc/mkinstalldirs

# Files
#
SUBDIR        = c gc gmp
LIBRARIES     =
TARGETS       = ecl2$(EXE)
DEF           = ecl.def

# Additional modules
# 
ECL_MODULES  =
ECL_FEATURES = (cons :wants-dlopen *features*)
!ifdef ECL_CMP
ECL_MODULES  = $(ECL_MODULES) cmp
ECL_FEATURES = (cons :wants-cmp $(ECL_FEATURES))
!endif
!ifdef ECL_ASDF
ECL_MODULES  = $(ECL_MODULES) asdf
ECL_FEATURES = (cons :wants-asdf $(ECL_FEATURES))
!endif
!ifdef ECL_SOCKETS
ECL_MODULES  = $(ECL_MODULES) sockets
ECL_FEATURES = (cons :wants-sockets $(ECL_FEATURES))
!endif
!ifdef ECL_CLX
ECL_MODULES  = $(ECL_MODULES) clx
ECL_FEATURES = (cons :wants-clx $(ECL_FEATURES))
!endif
!ifdef ECL_RT
ECL_MODULES  = $(ECL_MODULES) rt
ECL_FEATURES = (cons :wants-rt $(ECL_FEATURES))
!endif
!ifdef ECL_DEFSYS
ECL_MODULES  = $(ECL_MODULES) defsystem
ECL_FEATURES = (cons :wants-defsystem $(ECL_FEATURES))
!endif
!ifdef ECL_PROFILE
ECL_MODULES  = $(ECL_MODULES) profile
ECL_FEATURES = (cons :wants-profile $(ECL_FEATURES))
!endif
ECL_MODULES  = $(ECL_MODULES) bytecmp
ECL_FEATURES = (list* :builtin-bytecmp :wants-bytecmp $(ECL_FEATURES))

!MESSAGE ECL Modules: $(ECL_MODULES)
!MESSAGE ECL Features: $(ECL_FEATURES)

# Build rules
# 
all:	$(TARGETS) ecl-config.bat ecl-cc.bat
.PHONY:	all

%Makefile: $(srcdir)/%Makefile.in config.status
	./config.status

c\cut$(EXE): $(top_srcdir)\util\cut.c
	cd c
	$(MAKE) cut$(EXE)
	cd ..

$(TARGETS): $(UCDDAT) ecl_min$(EXE) compile.lsp sysfun.lsp BUILD-STAMP
	set ECLDIR=./
	ecl_min < compile.lsp
BUILD-STAMP: Makefile
	date /t > $@

ecl-static.lib: $(TARGETS)
	link /lib /out:$@ eclmin.lib c\all_symbols2.obj lsp.lib eclgmp.lib eclgc.lib

ucd.dat: $(top_srcdir)\..\contrib\unicode\ucd.dat
	copy $(top_srcdir)\..\contrib\unicode\ucd.dat .

ecl_min$(EXE): $(LIBRARIES) eclmin.lib $(UCDDAT)
	$(CC) /Fe$@ cinit.obj c\all_symbols.obj eclmin.lib $(LDFLAGS) $(LIBS)
	if exist ecl_min$(EXE).manifest \
	 mt -manifest ecl_min.exe.manifest -outputresource:ecl_min.exe;1
	-$(RM) ecl_min.exp ecl_min.lib ecl_min$(EXE).manifest

.gdbinit: $(srcdir)\util\gdbinit
	$(CP) $(srcdir)\util\gdbinit $@

lsp/config.lsp: $(srcdir)/lsp/config.lsp.in Makefile c\cut$(EXE)
	if not exist lsp $(MKDIR) lsp
	c\cut "@ecldir\@" "$(libdir:\=/)" \
	    "@SHORT_SITE_NAME@" "$(SHORT_SITE_NAME)" \
	    "@LONG_SITE_NAME@" "$(LONG_SITE_NAME)" \
	    "@PACKAGE_VERSION@" "$(ECL_VERSION)" \
	    "@ARCHITECTURE@" "$(ARCHITECTURE)" \
	    "@SOFTWARE_TYPE@" "$(SOFTWARE_TYPE)" \
	    "@SOFTWARE_VERSION@" "$(SOFTWARE_VERSION)" \
	    "@thehost@" "$(THEHOST)" \
	    "@true_srcdir@" "$(srcdir:\=/)" \
	    "@top_srcdir@" "$(top_srcdir:\=/)/" \
	    < $(srcdir)\lsp\config.lsp.in > lsp\config.lsp
compile.lsp: bare.lsp $(srcdir)/compile.lsp.in Makefile
	c\cut "@ecldir\@" "$(libdir:\=/)" \
	    "@libdir\@" "$(libdir:\=/)" \
	    "@true_srcdir@" "$(srcdir:\=/)" \
	    "@true_builddir@" "$(MAKEDIR:\=/)" \
	    "@CFLAGS@" "$(CFLAGS) -DGC_BUILD" \
	    "@ECL_CFLAGS@" "" \
	    "@CPPFLAGS@" "" \
	    "@ECL_LDRPATH@" "" \
	    "@LDFLAGS@" "$(LDFLAGS)" \
	    "@SHARED_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@BUNDLE_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@CLIBS@" "user32.lib ws2_32.lib shell32.lib" \
	    "@STATICLIBS@" "eclgmp.lib eclgc.lib" \
	    "@LIBS@" "user32.lib ws2_32.lib shell32.lib" \
	    "@CORE_LIBS@" "" \
	    "@FASL_LIBS@" "" \
	    "@OBJEXT@" "obj" \
	    "@SHAREDPREFIX@" "" \
	    "@SHAREDEXT@" "lib" \
	    "@LIBPREFIX@" "" \
	    "@LIBEXT@" "lib" \
	    "@EXEEXT@" ".exe" \
	    "@LDINSTALLNAME@" "" \
	    "@DEF@" "$(DEF)" \
            "@RANLIB@" "ranlib" \
	    "@LSP_FEATURES@" "$(ECL_FEATURES)" \
	    "@ECL_CMPDIR@" "cmp" \
	    < $(srcdir)\compile.lsp.in > compile.lsp
bare.lsp: $(srcdir)/bare.lsp.in lsp/load.lsp clos/load.lsp cmp/load.lsp cmp/cmpdefs.lsp
	c\cut "@true_srcdir@" "$(srcdir:\=/)" \
	    "@true_builddir@" "$(MAKEDIR:\=/)"\
	    "@ECL_CMPDIR@" "cmp" < $(srcdir)\bare.lsp.in > bare.lsp
lsp/load.lsp: $(srcdir)/lsp/load.lsp.in
	$(CP) $(srcdir)\lsp\load.lsp.in lsp\load.lsp
clos/load.lsp: $(srcdir)/clos/load.lsp.in
	if not exist clos $(MKDIR) clos
	$(CP) $(srcdir)\clos\load.lsp.in clos\load.lsp
cmp/load.lsp: $(srcdir)/cmp/load.lsp.in
	if not exist cmp $(MKDIR) cmp
	$(CP) $(srcdir)\cmp\load.lsp.in cmp\load.lsp
cmp/cmpdefs.lsp: $(srcdir)/cmp/cmpdefs.lsp Makefile
	c\cut "@ECL_CC@" "$(CC)" \
	    "@CFLAGS@" "$(CFLAGS)" \
	    "@CFLAGS_OPTIMIZE@" "$(CFLAGS_OPTIMIZE)" \
	    "@ECL_CFLAGS@" "" \
	    "@CPPFLAGS@" "" \
	    "@ECL_LDRPATH@" "" \
	    "@LDFLAGS@" "$(LDFLAGS)" \
	    "@SHARED_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@BUNDLE_LDFLAGS@" "$(SHARED_LDFLAGS)" \
	    "@CLIBS@" "user32.lib ws2_32.lib shell32.lib" \
	    "@STATICLIBS@" "eclgmp.lib eclgc.lib" \
	    "@OBJEXT@" "obj" \
	    "@SHAREDPREFIX@" "" \
	    "@SHAREDEXT@" "dll" \
	    "@LIBPREFIX@" "" \
	    "@LIBEXT@" "lib" \
	    "@EXEEXT@" ".exe" \
	    "@ecldir\@" "NIL" \
	    "@libdir\@" "NIL" \
	    "@includedir\@" "NIL" \
	    < $(srcdir)\cmp\cmpdefs.lsp > cmp\cmpdefs.lsp
ecl-config.bat: util\ecl-config.bat Makefile
	c\cut "~A" "$(libdir:\=/)"\
	    "~*" "" \
	    "@ECL_CFLAGS@" "$(CFLAGS)" \
	    "@LDFLAGS@" "$(LDFLAGS)" \
	    "@CLIBS@" "" \
	    "@libdir@" "$(prefix:\=/)" \
	    "@includedir@" "$(prefix:\=/)/ecl" \
	    < util\ecl-config.bat > ecl-config.bat
ecl-cc.bat: util\ecl-cc.bat Makefile
	c\cut "@ECL_CFLAGS@" "$(CFLAGS)" \
	      "@LDFLAGS@" "$(LDFLAGS)" \
	      "@CLIBS@" "" \
	      "@libdir@" "$(prefix:\=/)" \
	      "@includedir@" "$(prefix:\=/)/ecl" \
	      < util\ecl-cc.bat > ecl-cc.bat


eclmin.lib: eclgmp.lib eclgc.lib lsp/config.lsp
	cd c
	$(MAKE) ECL_VERSION_NUMBER=$(ECL_VERSION_NUMBER) \
	        ECL_THREADS=$(ECL_THREADS) ECL_UNICODE=$(ECL_UNICODE) \
		ECL_SSE=$(ECL_SSE) "ECL_CFLAGS=$(CFLAGS) -DGC_BUILD"
	cd ..
eclgc.lib:
	cd gc
	$(MAKE) $(GCFLAGS) ECL_THREADS=$(ECL_THREADS) "CFLAGS_CONFIG=$(CFLAGS_CONFIG)" "MY_CPU=$(GC_CPU)" gc.lib
	$(CP) gc.lib ..\eclgc.lib
	cd ..
	if not exist ecl\gc $(MKDIR) ecl\gc
	if not exist ecl\gc\private $(MKDIR) ecl\gc\private
	for %h in (gc.h gc_version.h gc_local_alloc.h gc_pthread_redirects.h \
	           gc_config_macros.h leak_detector.h gc_typed.h \
	           private\gc_priv.h private\gcconfig.h gc_mark.h \
		   new_gc_alloc.h weakpointer.h gc_pthread_redirects.h) \
	    do $(CP) $(srcdir)\gc\include\%h ecl\gc\%h
	$(CP) $(srcdir)\gc\libatomic_ops-1.2\src\atomic_ops.h ecl\gc
eclgmp.lib:
	cd gmp
	$(MAKE) "MPN_TYPE=$(GMP_TYPE)" "CFLAGS_CONFIG=$(CFLAGS_CONFIG)" \
		"BITS=$(GMP_BITS)"
	$(CP) gmp.lib ..\eclgmp.lib
	$(CP) gmp.h ..\ecl\gmp.h
	cd ..
sysfun.lsp:
	$(CP) $(srcdir)\cmp\sysfun.lsp .\

rt.lisp:
	$(CP) $(srcdir)\..\contrib\rt\rt.lisp .\

install:
	IF NOT EXIST "$(prefix)" $(MKDIR) "$(prefix)"
	IF NOT EXIST "$(bindir)" $(MKDIR) "$(bindir)"
	for %i in ($(TARGETS) ecl.dll $(UCDDAT)) do $(CP) %i "$(bindir)\%i"
	IF EXIST "$(bindir)\ecl2$(EXE)" $(MV) "$(bindir)\ecl2$(EXE)" "$(bindir)\ecl$(EXE)"
	IF EXIST ecl2$(EXE).manifest $(CP) ecl2$(EXE).manifest "$(bindir)\ecl$(EXE).manifest"
	IF EXIST ecl.dll.manifest $(CP) ecl.dll.manifest "$(bindir)"
	$(CP) ecl-config.bat "$(bindir)\ecl-config.bat"
	$(CP) ecl-cc.bat "$(bindir)\ecl-cc.bat"
	IF NOT EXIST "$(includedir)\ecl" $(MKDIR) "$(includedir)\ecl"
	IF NOT EXIST "$(includedir)\ecl\gc" $(MKDIR) $(includedir)\ecl\gc
	IF NOT EXIST "$(includedir)\ecl\gc\private" $(MKDIR) "$(includedir)\ecl\gc\private"
	for %i in (ecl\*.h ecl\gc\*.h ecl\gc\private\*.h) do $(CP) %i $(includedir)\%i
	cd c
	$(MAKE) cut.exe
	cd ..
	c\cut.exe < ecl\config.h > $(includedir)\ecl\config.h
	IF NOT EXIST "$(libdir)" $(MKDIR) "$(libdir)"
	IF NOT EXIST "$(libdir)\ecl" $(MKDIR) "$(libdir)\ecl"
	for %i in ($(LIBRARIES) c\dpp.exe BUILD-STAMP help.doc ecl.lib) do $(CP) %i "$(libdir)"
	for /f %i in ('type MODULES') do $(CP) %i "$(libdir)"
	for %i in (ecl-static.lib) do IF EXIST %i $(CP) %i "$(libdir)"
	IF NOT EXIST "$(docdir)" $(MKDIR) "$(docdir)"
	for %i in (..\Copyright ..\ANNOUNCEMENT ..\LGPL ..\README.1st ..\src\CHANGELOG) do $(CP) %i "$(docdir)"
!if "$(ECL_UNICODE)" != ""
	$(CP) $(UCDDAT) "$(libdir)"
	IF NOT EXIST "$(libdir)\encodings" $(MKDIR) "$(libdir)\encodings"
	$(CP) encodings\*.* "$(libdir)\encodings"
!endif

windows-nsi:

=== msvc/gc/Makefile ===
# Makefile for Windows NT.  Assumes Microsoft compiler.
# DLLs are included in the root set under NT, but not under win32S.
# Use "nmake nodebug=1 all" for optimized versions of library, gctest and editor.
# MY_CPU=i386 for 32 bits or AMD64 for 64 bits
CPU=$(MY_CPU)
!include <ntwin32.mak>

srcdir=..\..\src\gc

!if "$(ECL_THREADS)" != ""
THREADS_OBJ= win32_threads.obj thread_local_alloc.obj
THREADS_FLAGS= -D_CRT_SECURE_NO_WARNINGS -DGC_DLL -DGC_BUILD -DGC_WIN32_THREADS -DTHREAD_LOCAL_ALLOC -DLARGE_CONFIG
!else
THREADS_OBJ=
THREADS_FLAGS= -D_CRT_SECURE_NO_WARNINGS -DGC_DLL -DGC_BUILD -DLARGE_CONFIG
!endif

# Make sure that .cc is not viewed as a suffix.  It is for VC++2005, but
# not earlier versions.  We can deal with either, but not inconsistency.
.SUFFIXES:
.SUFFIXES: .obj .cpp .c

# Atomic_ops installation directory.  For win32, the source directory
# should do, since we only need the headers.
# We assume this was manually unpacked, since I'm not sure there is
# a Windows standard command line tool to do this.
AO_VERSION=1.2
AO_SRC_DIR=$(srcdir)/libatomic_ops-$(AO_VERSION)/src
AO_INCLUDE_DIR=$(AO_SRC_DIR)

OBJS= alloc.obj reclaim.obj allchblk.obj misc.obj mach_dep.obj os_dep.obj mark_rts.obj headers.obj mark.obj obj_map.obj blacklst.obj finalize.obj new_hblk.obj dbg_mlc.obj malloc.obj stubborn.obj dyn_load.obj typd_mlc.obj ptr_chck.obj gc_cpp.obj mallocx.obj win32_threads.obj msvc_dbg.obj thread_local_alloc.obj

all: gc.lib

{$(srcdir)}.c{}.obj:
	$(cc) $(cdebug) $(cflags) $(cvarsmt) $(CFLAGS_CONFIG) -Iinclude -I$(AO_INCLUDE_DIR) $(THREADS_FLAGS) -I$(srcdir)\include $< /Fo$*.obj

{$(srcdir)\tests}.c{tests}.obj:
	$(cc) $(cdebug) $(cflags) $(cvarsmt) $(CFLAGS_CONFIG) -Iinclude -I$(AO_INCLUDE_DIR) $(THREADS_FLAGS) -I$(srcdir)\include $< /Fo$*.obj

{$(srcdir)}.cpp{}.obj:
	$(cc) $(cdebug) $(cflags) $(cvarsmt) $(CFLAGS_CONFIG) -Iinclude -I$(AO_INCLUDE_DIR) $(THREADS_FLAGS) -I$(srcdir)\include $< /Fo$*.obj

$(OBJS) tests\test.obj: $(srcdir)\include\private\gc_priv.h $(srcdir)\include\private\gc_hdrs.h $(srcdir)\include\gc.h $(srcdir)\include\private\gcconfig.h $(srcdir)\include\private\gc_locks.h $(srcdir)\include\private\gc_pmark.h $(srcdir)\include\gc_mark.h $(srcdir)\include\private\msvc_dbg.h

gc.lib: $(OBJS)
!if "$(CPU)" == "i386"
	lib /MACHINE:i386 /out:gc.lib $(OBJS)
!else
	lib /MACHINE:X64 /out:gc.lib $(OBJS)
!endif
# The original NT SDK used lib32 instead of lib

gctest.exe: tests\test.obj gc.lib
#	The following works for win32 debugging.  For win32s debugging use debugtype:coff
#	and add mapsympe line.
#  This produces a "GUI" applications that opens no windows and writes to the log file
#  "gc.log".  This is done to make the result runnable under win32s.
	$(link) -debug:full -debugtype:cv $(guiflags) -stack:131072 -out:$*.exe tests\test.obj $(guilibs) gc.lib
#	mapsympe -n -o gctest.sym gctest.exe

cord\de_win.rbj: cord\de_win.res
	cvtres /MACHINE:$(MY_CPU) /OUT:cord\de_win.rbj cord\de_win.res

cord\de.obj cord\de_win.obj: $(srcdir)\include\cord.h $(srcdir)\include\private\cord_pos.h cord\de_win.h cord\de_cmds.h

cord\de_win.res: cord\de_win.rc cord\de_win.h cord\de_cmds.h
	$(rc) $(rcvars) -r -fo cord\de_win.res cord\de_win.rc

# Cord/de is a real win32 gui application.
cord\de.exe: cord\cordbscs.obj cord\cordxtra.obj cord\de.obj cord\de_win.obj cord\de_win.rbj gc.lib
	$(link) -debug:full -debugtype:cv $(guiflags) -stack:16384 -out:cord\de.exe  cord\cordbscs.obj cord\cordxtra.obj cord\de.obj cord\de_win.obj cord\de_win.rbj gc.lib $(guilibs)

gc_cpp.obj: $(srcdir)\include\gc_cpp.h $(srcdir)\include\gc.h

gc_cpp.cpp: $(srcdir)\gc_cpp.cc
	copy $? $@

test_cpp.cpp: $(srcdir)\tests\test_cpp.cc
	copy $? $@

# This generates the C++ test executable.  The executable expects
# a single numeric argument, which is the number of iterations.
# The output appears in the file "gc.log".
test_cpp.exe: test_cpp.obj $(srcdir)\include\gc_cpp.h $(srcdir)\include\gc.h gc.lib
	$(link) -debug:full -debugtype:cv $(guiflags) -stack:16384 -out:test_cpp.exe test_cpp.obj gc.lib $(guilibs)

AO_SCR_DIR:
	        tar xvfz $(AO_SRC_DIR).tar.gz;

=== msvc/gmp/Makefile ===
srcdir = ..\..\src\gmp

#
# Change for other configurations
#
BITS=32

AUTO_SUBDIRS = mpf mpq printf scanf

MPN_GC_SOURCES = \
    mpn\generic\add.c \
    mpn\generic\add_1.c \
    mpn\generic\add_n.c \
    mpn\generic\addmul_1.c \
    .\mpn\generic\addsub_n.c \
    mpn\generic\bdivmod.c \
    mpn\generic\cmp.c \
    mpn\generic\dc_divrem_n.c \
    mpn\generic\dive_1.c \
    mpn\generic\diveby3.c \
    mpn\generic\divis.c \
    mpn\generic\divrem.c \
    .\mpn\generic\divrem_1.c \
    .\mpn\generic\divrem_2.c \
    mpn\generic\dump.c \
    mpn\generic\fib2_ui.c \
    mpn\generic\gcd.c \
    mpn\generic\gcd_1.c \
    mpn\generic\gcdext.c \
    mpn\generic\get_d.c \
    mpn\generic\get_str.c \
    mpn\generic\jacbase.c \
    mpn\generic\lshift.c \
    mpn\generic\mod_1.c \
    mpn\generic\mod_34lsub1.c \
    mpn\generic\mode1o.c \
    mpn\generic\mul.c \
    mpn\generic\mul_1.c \
    mpn\generic\mul_basecase.c \
    mpn\generic\mul_fft.c \
    mpn\generic\mul_n.c \
    mpn\generic\mullow_basecase.c \
    mpn\generic\mullow_n.c \
    mpn\generic\perfsqr.c \
    .\mpn\generic\popham2.c \
    mpn\generic\pow_1.c \
    mpn\generic\pre_divrem_1.c \
    mpn\generic\pre_mod_1.c \
    mpn\generic\random.c \
    mpn\generic\random2.c \
    mpn\generic\rootrem.c \
    mpn\generic\rshift.c \
    mpn\generic\sb_divrem_mn.c \
    mpn\generic\scan0.c \
    mpn\generic\scan1.c \
    mpn\generic\set_str.c \
    mpn\generic\sizeinbase.c \
    mpn\generic\sqr_basecase.c \
    mpn\generic\sqrtrem.c \
    mpn\generic\sub.c \
    mpn\generic\sub_1.c \
    mpn\generic\sub_n.c \
    mpn\generic\submul_1.c \
    mpn\generic\tdiv_qr.c

MPF_SOURCES = \
    mpf\abs.c \
    mpf\add.c \
    mpf\add_ui.c \
    mpf\ceilfloor.c \
    mpf\clear.c \
    mpf\cmp.c \
    mpf\cmp_d.c \
    mpf\cmp_si.c \
    mpf\cmp_ui.c \
    mpf\div.c \
    mpf\div_2exp.c \
    mpf\div_ui.c \
    mpf\dump.c \
    mpf\eq.c \
    mpf\fits_sint.c \
    mpf\fits_slong.c \
    mpf\fits_sshort.c \
    mpf\fits_uint.c \
    mpf\fits_ulong.c \
    mpf\fits_ushort.c \
    mpf\get_d.c \
    mpf\get_d_2exp.c \
    mpf\get_dfl_prec.c \
    mpf\get_prc.c \
    mpf\get_si.c \
    mpf\get_str.c \
    mpf\get_ui.c \
    mpf\init.c \
    mpf\init2.c \
    mpf\inp_str.c \
    mpf\int_p.c \
    mpf\iset.c \
    mpf\iset_d.c \
    mpf\iset_si.c \
    mpf\iset_str.c \
    mpf\iset_ui.c \
    mpf\mul.c \
    mpf\mul_2exp.c \
    mpf\mul_ui.c \
    mpf\neg.c \
    mpf\out_str.c \
    mpf\pow_ui.c \
    mpf\random2.c \
    mpf\reldiff.c \
    mpf\set.c \
    mpf\set_d.c \
    mpf\set_dfl_prec.c \
    mpf\set_prc.c \
    mpf\set_prc_raw.c \
    mpf\set_q.c \
    mpf\set_si.c \
    mpf\set_str.c \
    mpf\set_ui.c \
    mpf\set_z.c \
    mpf\size.c \
    mpf\sqrt.c \
    mpf\sqrt_ui.c \
    mpf\sub.c \
    mpf\sub_ui.c \
    mpf\swap.c \
    mpf\trunc.c \
    mpf\ui_div.c \
    mpf\ui_sub.c \
    mpf\urandomb.c \

MPQ_SOURCES = \
    mpq\abs.c \
    mpq\aors.c \
    mpq\canonicalize.c \
    mpq\clear.c \
    mpq\cmp.c \
    mpq\cmp_si.c \
    mpq\cmp_ui.c \
    mpq\div.c \
    mpq\equal.c \
    mpq\get_d.c \
    mpq\get_den.c \
    mpq\get_num.c \
    mpq\get_str.c \
    mpq\init.c \
    mpq\inp_str.c \
    mpq\inv.c \
    mpq\md_2exp.c \
    mpq\mul.c \
    mpq\neg.c \
    mpq\out_str.c \
    mpq\set.c \
    mpq\set_d.c \
    mpq\set_den.c \
    mpq\set_f.c \
    mpq\set_num.c \
    mpq\set_si.c \
    mpq\set_str.c \
    mpq\set_ui.c \
    mpq\set_z.c \
    mpq\swap.c

MPZ_SOURCES = \
    mpz\abs.c \
    mpz\add.c \
    mpz\add_ui.c \
    mpz\and.c \
    mpz\aorsmul.c \
    mpz\aorsmul_i.c \
    mpz\array_init.c \
    mpz\bin_ui.c \
    mpz\bin_uiui.c \
    mpz\cdiv_q.c \
    mpz\cdiv_q_ui.c \
    mpz\cdiv_qr.c \
    mpz\cdiv_qr_ui.c \
    mpz\cdiv_r.c \
    mpz\cdiv_r_ui.c \
    mpz\cdiv_ui.c \
    mpz\cfdiv_q_2exp.c \
    mpz\cfdiv_r_2exp.c \
    mpz\clear.c \
    mpz\clrbit.c \
    mpz\cmp.c \
    mpz\cmp_d.c \
    mpz\cmp_si.c \
    mpz\cmp_ui.c \
    mpz\cmpabs.c \
    mpz\cmpabs_d.c \
    mpz\cmpabs_ui.c \
    mpz\com.c \
    mpz\combit.c \
    mpz\cong.c \
    mpz\cong_2exp.c \
    mpz\cong_ui.c \
    mpz\dive_ui.c \
    mpz\divegcd.c \
    mpz\divexact.c \
    mpz\divis.c \
    mpz\divis_2exp.c \
    mpz\divis_ui.c \
    mpz\dump.c \
    mpz\export.c \
    mpz\fac_ui.c \
    mpz\fdiv_q.c \
    mpz\fdiv_q_ui.c \
    mpz\fdiv_qr.c \
    mpz\fdiv_qr_ui.c \
    mpz\fdiv_r.c \
    mpz\fdiv_r_ui.c \
    mpz\fdiv_ui.c \
    mpz\fib2_ui.c \
    mpz\fib_ui.c \
    mpz\fits_sint.c \
    mpz\fits_slong.c \
    mpz\fits_sshort.c \
    mpz\fits_uint.c \
    mpz\fits_ulong.c \
    mpz\fits_ushort.c \
    mpz\gcd.c \
    mpz\gcd_ui.c \
    mpz\gcdext.c \
    mpz\get_d.c \
    mpz\get_d_2exp.c \
    mpz\get_si.c \
    mpz\get_str.c \
    mpz\get_ui.c \
    mpz\getlimbn.c \
    mpz\hamdist.c \
    mpz\import.c \
    mpz\init.c \
    mpz\init2.c \
    mpz\inp_raw.c \
    mpz\inp_str.c \
    mpz\invert.c \
    mpz\ior.c \
    mpz\iset.c \
    mpz\iset_d.c \
    mpz\iset_si.c \
    mpz\iset_str.c \
    mpz\iset_ui.c \
    mpz\jacobi.c \
    mpz\kronsz.c \
    mpz\kronuz.c \
    mpz\kronzs.c \
    mpz\kronzu.c \
    mpz\lcm.c \
    mpz\lcm_ui.c \
    mpz\lucnum2_ui.c \
    mpz\lucnum_ui.c \
    mpz\millerrabin.c \
    mpz\mod.c \
    mpz\mul.c \
    mpz\mul_2exp.c \
    mpz\mul_si.c \
    mpz\mul_ui.c \
    mpz\n_pow_ui.c \
    mpz\neg.c \
    mpz\nextprime.c \
    mpz\out_raw.c \
    mpz\out_str.c \
    mpz\perfpow.c \
    mpz\perfsqr.c \
    mpz\popcount.c \
    mpz\pow_ui.c \
    mpz\powm.c \
    mpz\powm_ui.c \
    mpz\pprime_p.c \
    mpz\random.c \
    mpz\random2.c \
    mpz\realloc.c \
    mpz\realloc2.c \
    mpz\remove.c \
    mpz\root.c \
    mpz\rootrem.c \
    mpz\rrandomb.c \
    mpz\scan0.c \
    mpz\scan1.c \
    mpz\set.c \
    .\mpz\set_d.c \
    mpz\set_f.c \
    mpz\set_q.c \
    mpz\set_si.c \
    mpz\set_str.c \
    mpz\set_ui.c \
    mpz\setbit.c \
    mpz\size.c \
    mpz\sizeinbase.c \
    mpz\sqrt.c \
    mpz\sqrtrem.c \
    mpz\sub.c \
    mpz\sub_ui.c \
    mpz\swap.c \
    mpz\tdiv_q.c \
    mpz\tdiv_q_2exp.c \
    mpz\tdiv_q_ui.c \
    mpz\tdiv_qr.c \
    mpz\tdiv_qr_ui.c \
    mpz\tdiv_r.c \
    mpz\tdiv_r_2exp.c \
    mpz\tdiv_r_ui.c \
    mpz\tdiv_ui.c \
    mpz\tstbit.c \
    mpz\ui_pow_ui.c \
    mpz\ui_sub.c \
    mpz\urandomb.c \
    mpz\urandomm.c \
    mpz\xor.c

PRINTF_SOURCES = \
    printf\asprintf.c \
    printf\asprntffuns.c \
    printf\doprnt.c \
    printf\doprntf.c \
    printf\doprnti.c \
    printf\fprintf.c \
    printf\obprintf.c \
    printf\obprntffuns.c \
    printf\obvprintf.c \
    printf\printf.c \
    printf\printffuns.c \
    printf\repl-vsnprintf.c \
    printf\snprintf.c \
    printf\snprntffuns.c \
    printf\sprintf.c \
    printf\sprintffuns.c \
    printf\vasprintf.c \
    printf\vfprintf.c \
    printf\vprintf.c \
    printf\vsnprintf.c \
    printf\vsprintf.c

SCANF_SOURCES = \
    scanf\doscan.c \
    scanf\fscanf.c \
    scanf\fscanffuns.c \
    scanf\scanf.c \
    scanf\sscanf.c \
    scanf\sscanffuns.c \
    scanf\vfscanf.c \
    scanf\vscanf.c \
    scanf\vsscanf.c

GMP_SOURCES = \
    assert.c \
    compat.c \
    errno.c \
    extract-dbl.c \
    invalid.c \
    memory.c \
    mp_bpl.c \
    mp_clz_tab.c \
    mp_dv_tab.c \
    mp_get_fns.c \
    mp_minv_tab.c \
    mp_set_fns.c \
    rand.c \
    randbui.c \
    randclr.c \
    randdef.c \
    randiset.c \
    randlc2s.c \
    randlc2x.c \
    randmt.c \
    randmts.c \
    randmui.c \
    rands.c \
    randsd.c \
    randsdui.c \
    tal-reent.c \
    version.c \
    mp_bases.c \
    fib_table.c

MPN_GC_OBJS = $(MPN_GC_SOURCES:.c=.obj)
#MPN_P0_OBJS = $(MPN_P0_ASM_SOURCES:.asm=.obj) $(MPN_P0_C_SOURCES:.c=.obj)
#MPN_P3_OBJS = $(MPN_P3_ASM_SOURCES:.asm=.obj) $(MPN_P3_C_SOURCES:.c=.obj)
#MPN_P4_OBJS = $(MPN_P4_ASM_SOURCES:.asm=.obj) $(MPN_P4_C_SOURCES:.c=.obj)
MPF_OBJS = $(MPF_SOURCES:.c=.obj)
MPQ_OBJS = $(MPQ_SOURCES:.c=.obj)
MPZ_OBJS = $(MPZ_SOURCES:.c=.obj)
PRINTF_OBJS = $(PRINTF_SOURCES:.c=.obj)
SCANF_OBJS = $(SCANF_SOURCES:.c=.obj)
GMP_OBJS = $(GMP_SOURCES:.c=.obj)

GMP_ALL_OBJS = $(MPF_OBJS) $(MPQ_OBJS) $(MPZ_OBJS) \
	       $(PRINTF_OBJS) $(SCANF_OBJS) $(GMP_OBJS)

AUTO_FILES = mp_bases.h mp_bases.c fac_ui.h fib_table.h fib_table.c perfsqr.h

MPN_TYPE = gc

all: $(AUTO_FILES) gmp.lib

mpn_gc.lib: msvc-build $(MPN_GC_OBJS)
	link -lib /NOLOGO /OUT:$@ $(MPN_GC_OBJS)

mpn_p0.lib: msvc-build $(MPN_P0_OBJS)
	link -lib /NOLOGO /OUT:$@ $(MPN_P0_OBJS)

mpn_p3.lib: msvc-build $(MPN_P3_OBJS)
	link -lib /NOLOGO /OUT:$@ $(MPN_P3_OBJS)

mpn_p4.lib: msvc-build $(MPN_P4_OBJS)
	link -lib /NOLOGO /OUT:$@ $(MPN_P4_OBJS)

gmp.lib: mpn_$(MPN_TYPE).lib $(GMP_ALL_OBJS)
	link -lib /NOLOGO /OUT:$@ *.obj mpf\*.obj mpz\*.obj mpq\*.obj $(PRINTF_OBJS) $(SCANF_OBJS) mpn_$(MPN_TYPE).lib

#CFLAGS = $(CFLAGS_CONFIG) /nologo /W3 /EHsc /I "." /I $(srcdir) /I "$(srcdir)\mpn\generic" /D "WIN32" /D "_LIB" /D "_WIN32" /D "_MBCS"
CFLAGS = $(CFLAGS_CONFIG) /nologo /W3 /EHsc /I "." /I $(srcdir) /I "$(srcdir)\mpn\generic" /D "_LIB" /D "_MBCS"

{.\mpn\generic}.c{.\mpn\generic}.obj:
	cl -c $(CFLAGS) /Fo$@ $?
{.\mpz}.c{.\mpz}.obj:
	cl -c $(CFLAGS) /Fo$@ $?
{$(srcdir)\mpn\generic}.c{mpn\generic}.obj:
	cl -c $(CFLAGS) /Fo$@ $?
{$(srcdir)\mpn}.c{mpn}.obj:
	cl -c $(CFLAGS) /Fo$@ $?
{$(srcdir)\mpf}.c{mpf}.obj:
	cl -c $(CFLAGS) /Fo$@ $?
{$(srcdir)\mpq}.c{mpq}.obj:
	cl -c $(CFLAGS) /Fo$@ $?
{$(srcdir)\mpz}.c{mpz}.obj:
	cl -c $(CFLAGS) /Fo$@ $?
{$(srcdir)\printf}.c{printf}.obj:
	cl -c $(CFLAGS) /Fo$@ $?
{$(srcdir)\scanf}.c{scanf}.obj:
	cl -c $(CFLAGS) /Fo$@ $?
{$(srcdir)}.c{}.obj:
	cl -c $(CFLAGS) /Fo$@ $?

.asm.obj:
	nasm -O9 -Xvc -f win32 -i $(@D)\ -o $@ $?

gen-bases.exe: build.vc8\gen-bases\gen-bases.c
	cl $(CFLAGS) /Fe$@ $?
	erase gen-bases.obj
mp_bases.h: gen-bases.exe
	gen-bases.exe header $(BITS) 0 > $@
mp_bases.c: gen-bases.exe
	gen-bases.exe table $(BITS) 0 > $@

gen-fac_ui.exe: build.vc8\gen-fac_ui\gen-fac_ui.c
	cl $(CFLAGS) /Fe$@ $?
	erase gen-fac_ui.obj
fac_ui.h: gen-fac_ui.exe
	gen-fac_ui.exe $(BITS) 0 > $@

gen-fib.exe: build.vc8\gen-fib\gen-fib.c
	cl $(CFLAGS) /Fe$@ $?
	erase gen-fib.obj
fib_table.h: gen-fib.exe
	gen-fib.exe header $(BITS) 0 > $@
fib_table.c: gen-fib.exe
	gen-fib.exe table $(BITS) 0 > $@

gen-psqr.exe: build.vc8\gen-psqr\gen-psqr.c
	cl $(CFLAGS) /Fe$@ $?
	erase gen-psqr.obj
perfsqr.h: gen-psqr.exe
	gen-psqr.exe $(BITS) 0 > $@


msvc-build: build.vc8\config-vc8.$(MPN_TYPE) build.vc8\gmp.h
	copy build.vc8\config-vc8.$(MPN_TYPE) config.h
	copy build.vc8\gmp.h gmp.h
	for %d in ($(AUTO_SUBDIRS)) do \
	  if not exist %d mkdir %d
	echo > $@

clean:
	-erase mpn\generic\*.obj
	-erase mpn\*.obj
	-erase mpf\*.obj
	-erase mpq\*.obj
	-erase mpz\*.obj
	-erase printf\*.obj
	-erase scanf\*.obj
	-erase *.obj
	-erase mpn_*.lib
	-erase gmp.lib
	-for %o in ($(MPN_P0_ASM_SOURCES:.asm=.obj)) do erase %o
	-for %o in ($(MPN_P3_ASM_SOURCES:.asm=.obj)) do erase %o
	-for %o in ($(MPN_P4_ASM_SOURCES:.asm=.obj)) do erase %o
	-for %d in ($(AUTO_SUBDIRS)) do rmdir /S /Q %d
	-for %o in ($(AUTO_FILES)) do erase %o
	-erase config.h
	-erase gmp.h
	-erase msvc-build
	-erase *.exe *.manifest

=== debian/changelog ===
ecl (11.1.1+dfsg1-2) unstable; urgency=low

  * Disable threads on kfreebsd (Closes: #696757). Thanks to Steven
    Chamberlain for the suggestion

 -- Christoph Egger <christoph@debian.org>  Sun, 17 Mar 2013 19:44:26 +0100

ecl (11.1.1+dfsg1-1) unstable; urgency=low
  
     * Remove GFDL documentation (Closes: #695718)
  
 -- Christoph Egger <christoph@debian.org>  Wed, 12 Dec 2012 16:25:48 -0800 

=== debian/control ===
Source: ecl
Section: devel
Priority: optional
Maintainer: Debian Common Lisp Team <pkg-common-lisp-devel@lists.alioth.debian.org>
Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
 Christoph Egger <christoph@debian.org>
Build-Depends: debhelper (>> 7.0.0),
 autotools-dev,
 libgmp-dev,
 automake1.9,
 file,
 texinfo,
 libncurses5-dev,
 fakeroot,
 libgc-dev (>= 1:7.1),
 chrpath,
 install-info,
 libatomic-ops-dev
Build-Conflicts: autoconf2.13, automake1.4
Standards-Version: 3.9.1
Homepage: http://ecls.sourceforge.net/
Vcs-Git: http://git.debian.org/git/pkg-common-lisp/ecl.git
Vcs-Browser: http://git.debian.org/?p=pkg-common-lisp/ecl.git;a=summary

Package: ecl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgmp3-dev, libncurses5-dev, libgc-dev, gcc
Conflicts: common-lisp-controller (<< 6.15)
Provides: lisp-compiler
Suggests: slime, ecl-doc
Description: Embeddable Common-Lisp: has an interpreter and can compile to C
 ECL stands for Embeddable Common-Lisp. The ECL project is an
 effort to modernize Giuseppe Attardi's ECL environment to
 produce an implementation of the Common-Lisp language
 which complies to the ANSI X3J13 definition of the language.
 .
 The current ECL implementation features:
  * A bytecodes compiler and interpreter.
  * A translator to C.
  * A UFFI-compatible interface to C code.
  * A dynamic loader.
  * The possibility to build standalone executables and DLLs.
  * The Common-Lisp Object System (CLOS).
  * Conditions and restarts for handling errors.
  * Sockets as ordinary streams.
  * The GNU Multiprecision library for fast bignum operations.
  * A simple conservative mark & sweep garbage collector.
  * The Boehm-Weiser garbage collector.

Package: ecl-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: ecl
Description: documentation for Embeddable Common-Lisp
 Contains the Info and HTML documentation.

=== debian/rules ===
--- 
+++ 
@@ -28,10 +28,16 @@
 endif
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 
 # gengc doesn't work on ia64 right now -- check again for next version
 ifneq ($(DEB_HOST_ARCH),ia64)
   confflags += --enable-gengc
+endif
+
+# threads seem broken currently except on Linux (see #696757, #648993)
+ifeq ($(DEB_HOST_ARCH_OS),linux)
+  confflags += --enable-threads=yes
 endif
 
 # force to use ginstall-info:
@@ -56,7 +62,6 @@
 	   --with-system-gmp=yes \
 	   --with-tcp \
 	   --with-clx  \
-	   --enable-threads=yes \
 	   --enable-boehm=system  \
 	   --with-x
